; Undeleter
; This is based loosely on the TI-83+ undeleter I wrote [checks ticalc.org]
; . . . woah, has it been that long?  Anyway, this is mostly a complete rewrite.

.binarymode ti8x

.nolist
; Archive Undelete, by Dr. D'nar
;
; Note:
; If an object's header crosses page boundries, it will not be processed.  This
; is for my own personal sanity.

#include "ti84pcse.inc"


;===============================================================================
;
; Equates
;

; Constants
firstpage	.equ	$08

; RAM
spaddr		.equ	plotSScreen
oldMathPrintFlags	.equ	spaddr + 2
currentPage		.equ	Asm_Flag1
itemSize		.equ	oldMathPrintFlags + 1





;===============================================================================
.list
;
; Header
;
	.org	userMem - 2
	.db	tExtTok, tAsm84CCmp
	
	; Save stack location for exit
	ld	(spaddr), sp
	; Save MathPrint flags so we can use screen BCALLs intelligently
;	ld	a, (iy + 44h)
;	ld	(oldMathPrintFlags), a
	res	2, (iy + 44h)
	ld	a, 1	; CPU speed
	out	(20h), a
	; Clear the screen
	b_call(_DrawStatusBar)
	b_call(_DrawStatusBarInfo)
	b_call(_ClrScrn)
	b_call(_HomeUp)
; Main Menu
	b_call(_RunIndicOff)
	ld	hl, bannerText
	call	DispStrings
;	b_call(_NewLine)
;	b_call(_GetKey)
	call	GetCSC

scan:
; Begin search.  Each sector of archive memory is four pages.  
; If the sector's first byte is $FE, it is the (a) swap
; sector.  If it is $F0, it has data.  If it has something else. . . eh, press
; onward.
; B is the page we are on
	;ld	(iy + currentPage), 8
	ld	b, 8
searchLoop:
	;ld	b, (iy + currentPage)
	in	a, (pFlashExecUpperLimit)
	cp	b
	jp	c, doneSearch
	ld	hl, 4000h
	b_call(_LoadCIndPaged)
	ld	a, c
	cp	$FE
	jr	z, nextSector
	cp	$F0
	jr	z, goodSector
;	cp	$FC				; BrandonW claims that $FC and $FF are also valid.
;	jr	z, goodSector			; As far as I can tell, they're not used.
;	cp	$FF
;	jr	z, goodSector

nextSector:
	;ld	a, (iy + currentPage)
	ld	a, b
	and	0FCh
	add	a, 4
	ld	b, a
	;ld	(iy + currentPage), a
	jr	searchLoop

goodSector:
; This scans the sector for data.  At the end of the page, the page is updated
; to the next, and $4000 is subtracted from the data pointer.  If a program is
; found, it displays it.
; HL is the address we are looking at
; B is the page we are on.  This is loaded from RAM when needed.
	
nextPageLoop:
	ld	hl, $4001
sectorSearch:
	;ld	b, (iy + currentPage)
	b_call(_LoadCIndPaged)
	ld	a, c
	cp	255
	jr	z, nextSector
	cp	0F0h
	jr	z, foundDeletedItem
	cp	0FCh
	jp	nz, errVarExtendsBeyondEndOfSector
unknownItem:
	call	incBhl
	b_call(_LoadDEIndPaged)	; increments HL
	call	incBhl
	call	bhlPlusDe
;	push	bc
;	push	hl
;	ld	a, b
;	call	DispByte
;	call	DispHL
;	b_call(_GetKey)
;	b_call(_ClrScrn)
;	b_call(_HomeUp)
;	pop	hl
;	pop	bc
	;ld	(iy + currentPage), b
	jr	sectorSearch
foundDeletedItem:
	push	bc
	push	hl
	call	incBhl
	b_call(_LoadDEIndPaged)
	ld	(itemSize), de
	call	incBhl
	b_call(_LoadCIndPaged)
	ld	a, c
	and	1Fh
	ld	(iy + Asm_Flag2), a
	cp	ProgObj
	jr	z, foundProg
	cp	ProtProgObj
	jr	z, foundProg
	cp	AppVarObj
	jr	z, foundProg
	pop	hl
	pop	bc
	jr	unknownItem
foundProg:
	call	incBhl3
	call	incBhl3
;	push	bc
;	push	hl
	ld	a, b
	ld	de, OP1
	ld	bc, 20
	b_call(_FlashToRam)
	ld	hl, OP1
	ld	e, (hl)
	ld	a, e
	inc	hl
	add	a, l
	ld	l, a
;	jr	nc, $ + 3
;	inc	h
	ld	(hl), 0
;	pop	hl
;	pop	bc
	ld	hl, 20
	b_call(_EnoughMem)
	jp	c, lowMem
	b_call(_ClrScrn)
	b_call(_HomeUp)
	pop	hl
	pop	bc
	push	bc
	push	hl
	ld	a, b
	call	DispByte
	call	DispHL
	ld	a, ' '
	b_call(_PutC)
	ld	a, (iy + Asm_Flag2)
	cp	ProtProgObj
	jr	nz, {@}
	ld	a, 'p'
	jr	foundProgShowName
@:	cp	ProgObj
	jr	nz, {@}
	ld	a, 'P'
	jr	foundProgShowName
@:	ld	a, 'a'
foundProgShowName:
	b_call(_PutC)
	ld	a, ' '
	b_call(_PutC)
	ld	hl, OP1 + 1
	b_call(_PutS)
	ld	hl, (itemSize)
	b_call(_DispHL)
;	ld	hl, bytesMsg
;	b_call(_PutS)
	b_call(_NewLine)
	ld	hl, undeleteConfirm
	b_call(_PutS)
	call	GetCSC
	cp	skEnter
	jr	z, undeleteProg
	cp	sk2nd
	jr	z, undeleteProg
	cp	skClear
	jp	z, quitNoWait
	cp	skMode
	jp	z, quitNoWait
	pop	hl
	pop	bc
	jp	unknownItem
undeleteProg:
	ld	a, (iy + Asm_Flag2)
	ld	(OP1), a
	b_call(_ChkFindSym)
	jp	nc, nameExists
	ld	hl, 0
	b_call(_CreateProg)
	push	hl
	ex	de, hl
	ld	de, 2
	b_call(_DelMem)
	pop	hl
	ld	a, (iy + Asm_Flag2)
	ld	(hl), a
	dec	hl
	dec	hl
	dec	hl
	pop	de
;	ld	a, (hl)
;	call	DispByte
	ld	(hl), e
	dec	hl
;	ld	a, (hl)
;	call	DispByte
	ld	(hl), d
	dec	hl
	pop	bc
;	ld	a, (hl)
;	call	DispByte
	ld	(hl), b
	ld	(iy + currentPage), b
	push	bc
	push	de
	b_call(_NewLine)
	ld	hl, doneMsg
	call	DispStrings
	b_call(_NewLine)
	call	GetCSC
	cp	skClear
	jr	z, quitNoWait
	cp	skMode
	jr	z, quitNoWait
	pop	hl
	pop	bc
	jp	unknownItem
	


; = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
doneSearch:
	ld	hl, doneSearchMsg
;	b_call(_PutS)
	jr	msgQuit;quitNoNewLine
	
lowMem:
	ld	hl, lowMemMsg
	jr	msgQuit
nameExists:
	ld	hl, nameExistsMsg
	jr	msgQuit
errVarExtendsBeyondEndOfSector:
	ld	hl, varExtendsBeyondEndOfSectorMsg
;	jr	msgQuit
msgQuit:
	push	hl
	b_call(_NewLine)
	pop	hl
msgQuitNoNewLine:
	b_call(_PutS)
quit:
	b_call(_NewLine)
	bit	5, (iy + 44h)	; MathPrint?
	jr	nz, {@}
	in	a, (pMPgAHigh)	; Shell?
	rra
	jr	c, {@}
	in	a, (pMPgA)
	cp	8
	jr	c, quitNoWait
@:	call	GetCSC
	b_call(_ClrScrn)
	b_call(_HomeUp)
quitNoWait:
	ld	sp, (spaddr)
;	b_call(_RunIndicOn)
	res	DonePrgm, (iy + DoneFlags)
;	ld	a, (oldMathPrintFlags)
;	ld	(iy + 44h), a
	ret

;===============================================================================
;
; Routines
;
;cphlde:
;	or	a
;	sbc	hl,de
;	add	hl,de
;	ret


incBhl3:
	call	incBhl
incBhl2:
	call	incBhl
incBhl:
	inc	hl
	bit	7, h
	ret	z
	inc	b
	ret

bhlPlusDe:
	add	hl, de
	jr	c, {2@}
	bit	7, h
	ret	z
	inc	b
@:	push	de
	ld	de, 4000h
	sbc	hl, de	; C already reset
	pop	de
	bit	7, h
	ret	z
	inc	b
	jr	{-1@}
@:	inc	b
	inc	b
	inc	b
	bit	6, h
	set	6, h
	ret	z
	jp	errVarExtendsBeyondEndOfSector

GetCSC:
	ei
	halt
	b_call(_GetCSC)
	or	a
	ret	nz
	jr	GetCSC

DispStrings:
	ld	b, (hl)
	inc	hl
@:	push	bc
	b_call(_PutS)
	push	hl
	b_call(_NewLine)
	pop	hl
	pop	bc
	djnz	{-1@}
	ret	

DispHL:
; Input:
;  - HL
; Output:
;  - Word displayed
; Destroys:
;  - AF
	ld	a, h
	call	DispByte
	ld	a, l
DispByte:
; Input:
;  - A: Byte
; Output:
;  - Byte displayed
; Destroys:
;  - AF
	push	af
	rra
	rra
	rra
	rra
	call	+_
	pop	af
_:	or	0F0h
	daa
	add	a, 0A0h
	adc	a, 40h
	b_call(_PutC)
	ret



;===============================================================================
; 
; Data
;



bannerText:
	;        12345678901234567890123456
	.db	3
	.db	"Archive Undelete CSE", 0
	.db	"v1.22 Dr. D'nar", 0
pressAnyKeyMsg:
	.db	"Press any key. . .", 0
;	.db	"
;	.db	0
doneSearchMsg:
	.db	"Search complete."
	.db	0
undeleteConfirm:
	.db	"Undelete this?", 0
lowMemMsg:
	;        12345678901234567890123456
	.db	"Insufficient memory."
	.db	0
nameExistsMsg:
	.db	"Name exists."
	.db	0
;bytesMsg:
;	.db	" bytes", 0
doneMsg:
;	.db	"Extraction successful."
;	.db	0
	.db	6
	.db	"Your data has been", 0
	.db	"undeleted temporarily.", 0
	.db	"Unarchive, group, or send", 0
	.db	"the item to another calc", 0
	.db	"or computer to recover it", 0
	.db	"permanently.", 0
varExtendsBeyondEndOfSectorMsg:
	.db	"Archive error."
	.db	0


.echo	"Data size: ", $ - bannerText, " bytes\n"
.echo	"Total size: ", $ - userMem, " bytes\n"
.end
.end
